<?php

class Config {
	private static $items = array();
	private static $items_loaded = FALSE;

	public static function load_items()
	{
		if(!self::$items_loaded)
		{
			self::$items_loaded = TRUE;

			// Output a more useful message to the user when a config file isn't found.
			// This should only be seen by developers, not end users.
			if(!file_exists("config/config.php"))
			{
				die("Cannot find configuration file!");
			}

			// For development purposes, config.php should be a symlink to either
			// config.development.php or config.production.php.
			// A released version should rename config.production.php to config.php
			// and remove config.development.php.
			require("config/config.php");

			self::$items = $config;

			unset($config);
		}
	}

	public static function get_item($item_name)
	{
		if(isset(self::$items[$item_name]))
		{
			return self::$items[$item_name];
		}

		throw new Exception("Configuration item not set: " . $item_name);
	}
}

// Config uses static variables and functions, so this is it's "constructor"
Config::load_items();

/* End of config.php */
