<?php

class System_Update_Model {
	public static function run_update($filename)
	{
		require_once("helpers/filesystem.php");

		$retval = TRUE;
		$command_retval = 0;
		$junk_array = array();
		unset($junk_array);
		$temp_update_dir = "/tmp/update-temp/";
		$temp_post_update_dir = "/var/www/post-update/";
		$decrypted_filename = "/tmp/update.tgz";
		
		// Remove any left over update files
		$command = "rm -rf " . $temp_update_dir . " " . $temp_post_update_dir . " " . $decrypted_filename;
		exec($command);

		// Make directory for temporary update files
		Filesystem::mkdir_if_needed($temp_update_dir);

		if($retval)
		{
			// Decrypt update file
			$command = "echo shaed8Ai|gpg --batch -q --passphrase-fd 0 -o " . $decrypted_filename . " " . escapeshellarg($filename);
			exec($command, $junk_array, $command_retval);
			
			if($command_retval != 0)
			{
				$retval = FALSE;
				echo "Update failed at step 2 (Error " . $command_retval . ")<br />";
			}
		}

		if($retval)
		{
			// Build tar command to use
			$command = "tar --strip-components=1 --directory " . $temp_update_dir . " -xzf " . $decrypted_filename;
			exec($command, $junk_array, $command_retval);
			if($command_retval != 0)
			{
				$retval = FALSE;
				echo "Update failed at step 3 (Error " . $command_retval . ")<br />";
			}
		}

		if($retval)
		{
			// Build command to remove old files
			// This is potentially dangerous if the config is set incorrectly!
			$command = "rm -rf " . Config::get_item('app_fs_base') . "*";
			exec($command, $junk_array, $command_retval);
			if($command_retval != 0)
			{
				$retval = FALSE;
				echo "Update failed at step 4 (Error " . $command_retval . ")<br />";
			}
		}

		if($retval)
		{
			// Move post-update files
			exec("mv " . $temp_update_dir . "/post-update/ " . $temp_post_update_dir, $junk_array, $command_retval);
			if($command_retval != 0)
			{
				$retval = FALSE;
				echo "Update failed at step 5.1 (Error " . $command_retval . ")<br />";
			}
		}

		if($retval)
		{
			// Install newly unpacked application files
			exec("mv " . $temp_update_dir . "* " . Config::get_item('app_fs_base'), $junk_array, $command_retval);
			if($command_retval != 0)
			{
				$retval = FALSE;
				echo "Update failed at step 5.2 (Error " . $command_retval . ")<br />";
			}
		}

		if($retval)
		{
			// Run any post-update commands if they exist
			$post_update_script = $temp_post_update_dir . "post-update.sh";
			if(file_exists($post_update_script))
			{
				// Make sure post-update script is executable
				chmod($post_update_script, 0750);
				exec("/usr/bin/sudo " . $post_update_script, $junk_array, $command_retval);
				if($command_retval != 0)
				{
					$retval = FALSE;
					echo "Update failed at step 5.3 (Error " . $command_retval . ")<br />";
				}
			}
		}

		if($retval)
		{
			// Remove temporary update files
			exec("rm -rf " . $temp_update_dir . " " . $temp_post_update_dir . " " . $decrypted_filename, $junk_array, $command_retval);
			if($command_retval != 0)
			{
				$retval = FALSE;
				echo "Update failed at step 6 (Error " . $command_retval . ")<br />";
			}
		}

		return $retval;
	}

	public static function update_from_browser($control_name)
	{
		$filename = "/tmp/update.bin";
		$tmp_filename = $_FILES[$control_name]['tmp_name'];
		if(!is_uploaded_file($tmp_filename))
		{
			throw new Exception("Tried to update with a non-uploaded file! (" . $tmp_filename . ")");
		}
		move_uploaded_file($tmp_filename, $filename);

		$retval = self::run_update($filename);

		// Remove the uploaded file
		unlink($filename);

		return $retval;
	}
}

/* End of system_update_model.php */
