<?php
	require_once("models/login.php");
	require_once("models/mymix_preference.php");
	require_once("helpers/input.php");
	require_once("helpers/config.php");
	require_once("helpers/url.php");
	require_once("models/mymix_discover.php");
	require_once("helpers/ftp.php");
	require_once("helpers/filesystem.php");

	Login::require_login();

	$profile_name = Input::post('profile_name');
	if(empty($profile_name))
	{
		die("No profile selected!");
	}

	$online_devices = MyMix_Discover::get_devices("mymix");
	// pull preferences from all online devices
	foreach($online_devices as $this_device)
	{
		FTP::pull_mymix_preference($this_device['ip_address'], $this_device['mac']);
	}

	// look through all the devices
	$devices = array();
	$path = Config::get_item('mymix_devices_dir');
	exec("ls " . $path, $devices);
	foreach($devices as $mac)
	{
		// look through all the profiles on this device
		$profiles = array();
		$path = Config::get_item('mymix_devices_dir') . $mac . "/profiles/";
		exec("ls " . $path, $profiles);
		foreach($profiles as $this_profile)
		{
			if($this_profile == $profile_name)
			{
				// set the active profile
				$pref = new MyMix_Preference(Config::get_item('mymix_devices_dir') . $mac . "/prefs");
				$pref->set_current_profile($profile_name);
				$pref->save();

				// push preference
				foreach($online_devices as $this_device)
				{
					if($this_device['mac'] == $mac)
					{
						// found the device, push prefs to it
						FTP::push_mymix_preference($this_device['ip_address'], $this_device['mac']);
						break;
					}
				}

				break;
			}
		}
	}
	
	// Properly terminate the FTP session
    FTP::disconnect();
    
    // Ensure changes are written to disk
    Filesystem::sync();

	Url::redirect("select-mymix.php");

/* End of change-global-profile.php */
