<?php
	require_once("helpers/form.php");
	require_once("helpers/input.php");
	require_once("helpers/config.php");
	require_once("helpers/filesystem.php");
	
	$mac = Input::get('mac');
	$export_type = Input::get('export_type');

	switch($export_type)
	{
		case "mymix-profile":
			$export_name = Input::get('profile_name');
			$title = "Export MyMix Profile";
			break;
		case "mymix-pref":
			$export_name = $mac . " myMix preferences";
			$title = "Export MyMix Preferences";
			break;
		case "mymix-lock":
			$export_name = $mac . " myMix lock settings";
			$title = "Export MyMix Lock";
			break;
		case "iex16-pref":
			$export_name = $mac . " IEX16 preferences";
			$title = "Export IEX16 Preferences";
			break;
		case "mymix-device":
			require_once("models/mymix_preference.php");
			$pref = new MyMix_Preference(Config::get_item('mymix_devices_dir') . $mac . "/prefs");
			$export_name = $pref->get_unit_name() . " myMix device";
			$title = "Export MyMix Device";
			break;
		default:
			// catch any weird cases or hacking attempts
			throw new Exception("Unknown export type!");
			break;
	}

	$usb_mounted = Filesystem::is_usb_mounted();
	$usb_name = Filesystem::get_usb_name();
	if(empty($usb_name))
	{
		$usb_name = "(No USB drive found)";
	}

    $ID = "home";

	require("views/header.php");
	require("views/export-common.php");
	require("views/footer.php");

/* End of mymix-export-form.php */
