<?php

class XML {

	private static function indent_newline($level, $indent_string)
	{
		$retval = "\n";
		for($i = 0; $i < $level; $i++)
		{
			$retval .= $indent_string;
		}
		return $retval;
	}

	public static function pretty_format($input_xml)
	{
		/*$dom = new DOMDocument('1.0');
		$dom->preserveWhiteSpace = false;
		$dom->formatOutput = true;
		$dom->loadXML($input_xml);
		return $dom->saveXML();*/

		$retval = "";
		$indent_string = "    ";
		$indent_level = 0;
		$inside_a_tag = FALSE;
		$tag_type = "open";
		$previous_char = "";
		$this_char = "";
		$data_chars = "";
		$tag_chars = "";
		$prev_tag_type = "";
		
		for($char_index = 0; $char_index < strlen($input_xml); $char_index++)
		{
			$previous_char = $this_char;
			$this_char = $input_xml{$char_index};

			// start of a tag
			if($this_char == "<")
			{
				$inside_a_tag = TRUE;
			}
			// end of a tag
			elseif($this_char == ">" && $inside_a_tag)
			{
				// this is the xml version and encoding tag
				if($previous_char == "?")
				{
					$retval .= $tag_chars . $this_char;
				}
				// this is an open tag
				elseif($tag_type == "open")
				{
					$retval .= self::indent_newline($indent_level, $indent_string);
					$retval .= $tag_chars . $this_char;
					$indent_level++;
				}
				// this is a close tag
				elseif($tag_type == "close")
				{
					$indent_level--;
					if($prev_tag_type == "open")
					{
						$retval .= $data_chars;
					}
					else
					{
						$retval .= self::indent_newline($indent_level, $indent_string);
					}
					$retval .= $tag_chars . $this_char;
				}
				// this is a self-closing tag
				elseif($tag_type == "self-close")
				{
					$retval .= $tag_chars . $this_char;
					$retval .= self::indent_newline($indent_level, $indent_string);
				}

				$data_chars = "";
				$tag_chars = "";
				
				$prev_tag_type = $tag_type;
				$inside_a_tag = FALSE;
				$tag_type = "open";
				continue;
			}
			elseif($this_char == "/" && $inside_a_tag)
			{
				if($previous_char == "<")
				{
					$tag_type = "close";
				}
				else
				{
					$tag_type = "self-close";
				}
			}
			elseif($this_char == "/" && $inside_a_tag)
			{
				if($previous_char == "<")
				{
					$tag_type = "close";
				}
				else
				{
					$tag_type = "self-close";
				}
			}

			if($inside_a_tag)
			{
				$tag_chars .= $this_char;
			}
			else
			{
				$data_chars .= $this_char;
			}
		}
		return $retval;
	}
}

/* End of xml.php*/
