<?php

class MyMix_Device
{
	// Helper function for other device list functions
	private static function device_list_helper($folder)
	{
		$retval = array();

		$devices = array();
		if(is_dir($folder))
		{
			exec("ls " . $folder, $devices);
		}

		foreach($devices as $this_device)
		{
			$retval[$this_device] = $this_device;
		}

		return $retval;
	}

	public static function get_local_saved_devices()
	{
		require_once("helpers/config.php");

		$path = Config::get_item('saved_mymix_devices_dir');
		return self::device_list_helper($path);
	}

	public static function get_external_saved_devices()
	{
		require_once("helpers/config.php");

		$path = Config::get_item('external_mymix_devices_dir');
		return self::device_list_helper($path);
	}

	public static function delete_local_saved_device($device_name)
	{
		$path = Config::get_item('saved_mymix_devices_dir') . $device_name;
		unlink($path);
	}
}

/* end of mymix_device.php */
