<?php

class Project_File {
	private static $default_xml = <<< XML
<?xml version="1.0" encoding="iso-8859-1"?>
<project>
	<name>Project 1</name>
	<author>Unknown</author>
	<description>Project description</description>
</project>
XML;

	private $xml_data;
	private $xml_path;

	function __construct($filename)
	{
		$this->load($filename);
	}

	private function load($filename)
	{
		//libxml_use_internal_errors(true);

		// Only try to load the project file if it exists
		if(file_exists($filename))
		{
			$retval = simplexml_load_file($filename);
		}
		else
		{
			$retval = FALSE;
		}

		if($retval === FALSE)
		{
			/*$errors = libxml_get_errors();
			$error_message = "";
			foreach ($errors as $error)
			{
				$error_message .= $error->message . " in " . $error->file . " at line " . $error->line . ".\n";
			}

			throw new Exception("Failed to open file: " . $error_message);*/
			$retval = new SimpleXMLElement(self::$default_xml);
		}

		$this->xml_data = $retval;
		$this->xml_path = $filename;
	}

	public function save()
	{
		$result = file_put_contents($this->xml_path, $this->xml_data->saveXML());
		if($result === FALSE)
		{
			$error = error_get_last();
			throw new Exception("Failed to save file: " . $error['message']);
		}
	}

	public function get_name()
	{
		return (string)$this->xml_data->name;
	}

	public function set_name($name)
	{
		$this->xml_data->name = $name;
	}

	public function get_author()
	{
		return (string)$this->xml_data->author;
	}

	public function set_author($author)
	{
		$this->xml_data->author = $author;
	}

	public function get_description()
	{
		return (string)$this->xml_data->description;
	}

	public function set_description($description)
	{
		$this->xml_data->description = $description;
	}
}

/* End of project_file.php */
