<?php
	// Load required libraries
	require_once("models/mymix_profile.php");
	require_once("helpers/config.php");
	require_once("models/login.php");
	require_once("helpers/input.php");
	require_once("models/mymix_preference.php");
	require_once("models/mymix_discover.php");
	require_once("helpers/ftp.php");
	require_once("helpers/filesystem.php");

	Login::require_login();

	// Get data from libraries
	$mac = Input::get('mac');
    $new_value = Input::get('new_value');
    $profile_name = Input::get('profile_name');

    $prefs = new MyMix_Preference(Config::get_item('mymix_devices_dir') . $mac . "/prefs");
	$remote_device_profile = new MyMix_Profile(Config::get_item('mymix_devices_dir') .
		$mac . "/profiles/" . $prefs->get_current_profile());

    $remote_device_profile->set_transmit_stereo_mix($new_value);
    $remote_device_profile->save();

	// if this device is online, push the profile
	$devices = MyMix_Discover::get_devices("mymix");
	foreach($devices as $this_device)
	{
		if($this_device['mac'] == $mac)
		{
			FTP::push_mymix_profile($this_device['ip_address'], $mac, $profile_name);
			
			// Properly terminate the FTP session
            FTP::disconnect();
            
			break;
		}
	}

    sleep(1);
    
    // Ensure changes are written to disk
    Filesystem::sync();

	Url::redirect("select-mymix.php");
    
/* End of mymix-toggle-transmit-stereo.php */
