<?php

require_once("models/login.php");
require_once("helpers/url.php");
require_once("models/mymix_preference.php");
require_once("models/mymix_profile.php");
require_once("models/mymix_lock.php");
require_once("helpers/input.php");
require_once("helpers/validate.php");
require_once("helpers/filesystem.php");

Login::require_login();

$mac = Input::post('mac');
$name = Input::post('name');

if(!Validate::mac_address($mac))
{
	die("Invalid MAC address!");
}

$prefs = new MyMix_Preference(Config::get_item('mymix_devices_dir') . $mac . "/prefs");
$prefs->set_unit_name($name);
$prefs->save();

$profile = new MyMix_Profile(Config::get_item('mymix_devices_dir') . $mac . "/profiles/PROFILE 1");
$profile->save();

$locks = new MyMix_Lock($mac);
$locks->save();

// Ensure changes are written to disk
Filesystem::sync();

Url::redirect("select-mymix.php");

/* end of new-mymix-device.php */
