<?php

require_once("models/login.php");
require_once("helpers/input.php");
require_once("models/mymix_preference.php");

Login::require_login();

$reset_type = Input::get('reset_type');
$mac = Input::get('mac');

$prefs = new MyMix_Preference(Config::get_item('mymix_devices_dir') . $mac . "/prefs");
$unit_name = $prefs->get_unit_name();

switch($reset_type)
{
	case "lock":
		$reset_name = "lock settings";
		break;
	case "pref":
		$reset_name = "preferences";
		break;
	default:
		die("Unknown reset type! (" . $reset_type . ")");
		break;
}

$title = "Confirm reset to default";
$ID = "home";

require("views/header.php");
require("views/reset-form.php");
require("views/footer.php");

/* End of reset-to-default-form.php */
